<script lang="ts" setup>
import { useBSPaperStore } from '@/stores/bspaper'
import type { BSPaperItem } from '@/types/BSPaperItem'

import { computed, ref } from 'vue'
import type { VSheet } from 'vuetify/components'

const bspaperStore = useBSPaperStore()

const div = ref<HTMLElement | null>(null)

const scrollToBottom = () => {
  div.value!.scrollTo(0, div.value!.scrollHeight)
}

const props = withDefaults(
  defineProps<{
    editable: boolean
  }>(),
  { editable: true }
)

defineExpose({
  scrollToBottom
})
</script>
<template>
  <div class="overflow-auto" ref="div">
    <v-sheet max-width="600" min-width="300" height="280" elevation="3">
      <v-table>
        <thead>
          <tr>
            <td>#</td>
            <td>Name</td>
            <td>Price</td>
            <td>Qty</td>
            <td>Unit</td>
            <td>Total</td>
            <td></td>
          </tr>
        </thead>
        <tbody>
          <tr v-for="(item, index) of bspaperStore.bsPaperItems" :key="index">
            <td>{{ index + 1 }}</td>
            <td>{{ item.name }}</td>
            <td>{{ item.price }}</td>
            <!-- Qty -->
            <td>
              <v-btn
                v-if="props.editable === true"
                icon="mdi-minus"
                density="compact"
                @click="
                  () => {
                    bspaperStore.decQtyOfBSPaperItem(item)
                  }
                "
              ></v-btn
              ><span class="pl-3 pr-3">{{ item.qty }}</span>
              <v-btn
                v-if="props.editable === true"
                icon="mdi-plus"
                density="compact"
                @click="
                  () => {
                    bspaperStore.incQtyOfBSPaperItem(item)
                  }
                "
              ></v-btn>
            </td>
            <td>{{ item.unit }}</td>
            <!-- Total Price-->
            <td>{{ item.price * item.qty }}</td>
            <!-- Operation-->
            <td>
              <v-btn
                v-if="props.editable === true"
                density="compact"
                icon="mdi-delete"
                color="red"
                @click="
                  () => {
                    bspaperStore.removeItem(item)
                  }
                "
              ></v-btn>
            </td>
          </tr>
        </tbody>
      </v-table>
    </v-sheet>
  </div>
</template>
